package com.catsin.HitAndBlow;

import java.util.Random;

import android.app.Activity;
import android.os.Bundle;
import android.view.View;
import android.widget.Button;
import android.widget.TextView;

import android.view.Menu;
import android.view.MenuItem;

public class HitAndBlow extends Activity {

	Random	rand = new Random();

    private static final int D_STATUS_ONGAME_ID	= 1;
    private static final int D_STATUS_WAIT_ID	= 0;
	int		m_status	= D_STATUS_WAIT_ID;
	
	int		m_digits	= 4;
	int		m_input		= 0;
	int		m_answer	= 0;
    int		m_hit		= 0;
    int		m_blow		= 0;
    int		m_tryCount	= 0;

	/** Called when the activity is first created. */
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.main);

        Button	button_0		=(Button)findViewById(R.id.button_0_id);
        Button	button_1		=(Button)findViewById(R.id.button_1_id);
        Button	button_2		=(Button)findViewById(R.id.button_2_id);
        Button	button_3		=(Button)findViewById(R.id.button_3_id);
        Button	button_4		=(Button)findViewById(R.id.button_4_id);
        Button	button_5		=(Button)findViewById(R.id.button_5_id);
        Button	button_6		=(Button)findViewById(R.id.button_6_id);
        Button	button_7		=(Button)findViewById(R.id.button_7_id);
        Button	button_8		=(Button)findViewById(R.id.button_8_id);
        Button	button_9		=(Button)findViewById(R.id.button_9_id);
        Button	button_entry	=(Button)findViewById(R.id.button_entry_id);
        
        
        m_answer	= makeRandomNo( m_digits );
        
        renewInputNo( m_digits, m_input );
        renewHitCount( m_hit );
        renewBlowCount( m_blow );
        renewTryCount( m_tryCount );

        button_0.setOnClickListener( new View.OnClickListener(){
        	//@Override
        	public	void	onClick(View v){
        		m_input	= addDigitNo( m_digits, m_input, 0 );
                renewInputNo( m_digits, m_input );
        	}});
        button_1.setOnClickListener( new View.OnClickListener(){
        	//@Override
        	public	void	onClick(View v){
        		m_input	= addDigitNo( m_digits, m_input, 1 );
                renewInputNo( m_digits, m_input );
        	}});        
        button_2.setOnClickListener( new View.OnClickListener(){
        	//@Override
        	public	void	onClick(View v){
        		m_input	= addDigitNo( m_digits, m_input, 2 );
                renewInputNo( m_digits, m_input );
        	}});
        button_3.setOnClickListener( new View.OnClickListener(){
        	//@Override
        	public	void	onClick(View v){
        		m_input	= addDigitNo( m_digits, m_input, 3 );
                renewInputNo( m_digits, m_input );
        	}}); 
        button_4.setOnClickListener( new View.OnClickListener(){
        	//@Override
        	public	void	onClick(View v){
        		m_input	= addDigitNo( m_digits, m_input, 4 );
                renewInputNo( m_digits, m_input );
        	}});
        button_5.setOnClickListener( new View.OnClickListener(){
        	//@Override
        	public	void	onClick(View v){
        		m_input	= addDigitNo( m_digits, m_input, 5 );
                renewInputNo( m_digits, m_input );
        	}});
        button_6.setOnClickListener( new View.OnClickListener(){
        	//@Override
        	public	void	onClick(View v){
        		m_input	= addDigitNo( m_digits, m_input, 6 );
                renewInputNo( m_digits, m_input );
        	}});        
        button_7.setOnClickListener( new View.OnClickListener(){
        	//@Override
        	public	void	onClick(View v){
        		m_input	= addDigitNo( m_digits, m_input, 7 );
                renewInputNo( m_digits, m_input );
        	}});
        button_8.setOnClickListener( new View.OnClickListener(){
        	//@Override
        	public	void	onClick(View v){
        		m_input	= addDigitNo( m_digits, m_input, 8 );
                renewInputNo( m_digits, m_input );
        	}}); 
        button_9.setOnClickListener( new View.OnClickListener(){
        	//@Override
        	public	void	onClick(View v){
        		m_input	= addDigitNo( m_digits, m_input, 9 );
                renewInputNo( m_digits, m_input );
        	}}); 
        button_entry.setOnClickListener( new View.OnClickListener(){
        	//@Override
        	public	void	onClick(View v){
                Button	button_0		=(Button)findViewById(R.id.button_0_id);
                Button	button_1		=(Button)findViewById(R.id.button_1_id);
                Button	button_2		=(Button)findViewById(R.id.button_2_id);
                Button	button_3		=(Button)findViewById(R.id.button_3_id);
                Button	button_4		=(Button)findViewById(R.id.button_4_id);
                Button	button_5		=(Button)findViewById(R.id.button_5_id);
                Button	button_6		=(Button)findViewById(R.id.button_6_id);
                Button	button_7		=(Button)findViewById(R.id.button_7_id);
                Button	button_8		=(Button)findViewById(R.id.button_8_id);
                Button	button_9		=(Button)findViewById(R.id.button_9_id);
                Button	button_entry	=(Button)findViewById(R.id.button_entry_id);
                
        		switch( m_status ){
        		case	D_STATUS_WAIT_ID:	//wait start
                   	m_status = D_STATUS_ONGAME_ID;
                	m_input		= 0;
                	m_answer	= 0;
                    m_hit		= 0;
                    m_blow		= 0;
                    m_tryCount	= 0;
                    m_answer	= makeRandomNo( m_digits );
                    renewInputNo( m_digits, m_input );
                    renewHitCount( m_hit );
                    renewBlowCount( m_blow );
                    renewTryCount( m_tryCount );

                    button_0.setText("0");
                    button_1.setText("1");
                    button_2.setText("2");
                    button_3.setText("3");
                    button_4.setText("4");
                    button_5.setText("5");
                    button_6.setText("6");
                    button_7.setText("7");
                    button_8.setText("8");
                    button_9.setText("9");
                    button_entry.setText(getString(R.string.button_entry));
                   	break;
        		case	D_STATUS_ONGAME_ID:	//on game
            		m_tryCount++;
            		renewTryCount( m_tryCount );
            		
        			int	hitNo	= checkHitCount( m_digits, m_input, m_answer);
                    renewHitCount( hitNo );
                    renewBlowCount( checkBlowCount( m_digits, m_input, m_answer) );
                    
                    if( hitNo==m_digits ){
                    	m_status = D_STATUS_WAIT_ID;
                        button_entry.setText(getString(R.string.button_retry));
                    }
        			break;
        		}

        	}});
    }

    // j[
    private static final int D_MENU_RESTART_ID	= 0;
    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
    	boolean supRetVal = super.onCreateOptionsMenu(menu);
    	menu.add(0, D_MENU_RESTART_ID, 0, getString(R.string.menu_restart));
    	return supRetVal;
    }
    @Override public boolean onOptionsItemSelected(MenuItem item) {
        Button	button_0		=(Button)findViewById(R.id.button_0_id);
        Button	button_1		=(Button)findViewById(R.id.button_1_id);
        Button	button_2		=(Button)findViewById(R.id.button_2_id);
        Button	button_3		=(Button)findViewById(R.id.button_3_id);
        Button	button_4		=(Button)findViewById(R.id.button_4_id);
        Button	button_5		=(Button)findViewById(R.id.button_5_id);
        Button	button_6		=(Button)findViewById(R.id.button_6_id);
        Button	button_7		=(Button)findViewById(R.id.button_7_id);
        Button	button_8		=(Button)findViewById(R.id.button_8_id);
        Button	button_9		=(Button)findViewById(R.id.button_9_id);
        Button	button_entry	=(Button)findViewById(R.id.button_entry_id);

        switch (item.getItemId()) {
            case D_MENU_RESTART_ID:
               	m_status = D_STATUS_ONGAME_ID;
            	m_input		= 0;
            	m_answer	= 0;
                m_hit		= 0;
                m_blow		= 0;
                m_tryCount	= 0;
                m_answer	= makeRandomNo( m_digits );
                renewInputNo( m_digits, m_input );
                renewHitCount( m_hit );
                renewBlowCount( m_blow );
                renewTryCount( m_tryCount );

                button_0.setText("0");
                button_1.setText("1");
                button_2.setText("2");
                button_3.setText("3");
                button_4.setText("4");
                button_5.setText("5");
                button_6.setText("6");
                button_7.setText("7");
                button_8.setText("8");
                button_9.setText("9");
                button_entry.setText(getString(R.string.button_entry));
                return true;
            default:
                return super.onOptionsItemSelected(item);
        }
    }
    
    void	renewInputNo( int digits, int inputNo ){
    	String		format=String.format("%%0%dd", digits);
   		String		inputNoText=String.format( format, inputNo);
		
		TextView	tv=(TextView)findViewById(R.id.input_id);
		tv.setText(inputNoText);
	}
    void	renewHitCount( int hitCount ){
		String		hitCountText=String.format("%d", hitCount);
		TextView	tv=(TextView)findViewById(R.id.answer_hit_id);
		tv.setText(hitCountText);
	}
    void	renewBlowCount( int blowCount ){
		String		blowCountText=String.format("%d", blowCount);
		TextView	tv=(TextView)findViewById(R.id.answer_blow_id);
		tv.setText(blowCountText);
	}
    void	renewTryCount( int tryCount ){
		String		TryCountText=String.format("%d", tryCount);
		TextView	tv=(TextView)findViewById(R.id.trycount_id);
		tv.setText(TryCountText);
	}
    int		checkHitCount( int digits, int inputNo, int AnswerNo ){
    	int	dCnt	= 0;
    	int	cnt		= 0;
    	for( dCnt=0; dCnt<digits; dCnt++ ){
    		if( getDigitNo( inputNo, dCnt )==getDigitNo( AnswerNo, dCnt ) ){
    			cnt++;
    		}
    	}
    	return( cnt );
    }
    int		checkBlowCount( int digits, int inputNo, int AnswerNo ){
    	int			dCnt1	= 0;
    	int			dCnt2	= 0;
    	int			chkNo	= 0;
    	int			tmpNo	= 0;
    	int			tmpNo2	= 0;
    	int			cnt		= 0;
    	boolean	skipFlag	= false;
    	for( dCnt1=0; dCnt1<digits; dCnt1++ ){
    		chkNo		= getDigitNo( inputNo, dCnt1 );
    		skipFlag	= false;
			if( chkNo==getDigitNo( AnswerNo, dCnt1 ) ){
				skipFlag=true;
			}else{
				for( dCnt2=0; dCnt2<dCnt1; dCnt2++ ){
					if( chkNo==getDigitNo( inputNo, dCnt2) ){
						skipFlag=true;
						break;
					}
				}
			}
    		if( skipFlag!=true ){
    			for( dCnt2=0; dCnt2<digits; dCnt2++ ){
					tmpNo	= getDigitNo( AnswerNo, dCnt2 );
    				if( dCnt1!=dCnt2 ){
    					if( chkNo==tmpNo ){
    						tmpNo2	= getDigitNo( inputNo, dCnt2 );
    						if( tmpNo2!=tmpNo ){
    							cnt++;
    							break;
    						}
    					}
    				}
        		}
        	}
    	}
    	return( cnt );
    }
    int		addDigitNo( int digits, int inputNo, int addNo ){
    	int		cnt		= 0;
    	int		mask	= 1;
    	for( cnt=0; cnt<digits; cnt++ ){
    		mask	= mask*10;
    	}
    	inputNo		= inputNo * 10 + addNo;
    	inputNo		= inputNo % mask;
    	return( inputNo );
    }
    int		getDigitNo( int no, int digitNo ){
    	int		cnt		= 0;
    	int		mask	= 1;
    	for( cnt=0; cnt<digitNo; cnt++ ){
    		mask	= mask*10;
    	}
    	int	getNo	= (no%(mask*10) - no%(mask))/mask;
    	return( getNo );
    }
    int		makeRandomNo( int digits ){
    	int		cnt		= 0;
    	int		mask	= 1;
    	for( cnt=0; cnt<digits; cnt++ ){
    		mask	= mask*10;
    	}
		int		random=Math.abs(rand.nextInt()%mask);
    	return( random );
    }
}